// MODULE: 		menu.js
// AUTHOR:		Adrian Cornwell www.Dev2go.com
// DESCRIPTION:		Contains Javascript code for controlling drop down menus.
// 
// To use this menu code add the following code into your HTML Page (removing the // markers at the beginning of the lines):
//
//
//	<!-- START MENU CODE COPY HERE -->
//	<!-- The following Code is for the Close Menu Link -->  
//	<DIV STYLE='cursor:hand;' onClick='close_menu(-1)' >
//	Close Menu
//	</DIV>
//	
//	<!-- The following Code is for the Expand Menu Link -->  
//	<DIV STYLE='cursor:hand;' onClick='Show_All_Items()' >
//	Expand Menu
//	</DIV>
//
//	<!-- The following Code is used for the Loading Page Message -->  
//	<DIV ID="LOADING">Loading Page, Please Wait.....</DIV>
//	
//	<!-- DEFINE MENU ENVIRONMENT -->  
//	<!-- The following Code Defines the Graphics used for the buttons -->  
//	<META NAME="MENU_PLUS" CONTENT="_plus.jpg">
//	<META NAME="MENU_NONE" CONTENT="_none.jpg">
//	<META NAME="MENU_MINUS" CONTENT="_minus.jpg">
//
//	<!-- The following Tag can be used for fixing menu widths -->  
//	<!-- MENU_WIDTH_T	= Defines size for Top Level Menus -->
//	<!-- MENU_WIDTH_S	= Defines size for Sub Level Menus -->
//	<META NAME="MENU_WIDTH_T" CONTENT="WIDTH=100">
//
//	<!-- The following Tag Defines the type of Menu NORMAL,DROPDOWN -->  
//	<META NAME="MENU_TYPE" CONTENT="NORMAL">
//
//	<!-- The following Code is for Sizing the above Graphics (Pixcels) -->  
//	<META NAME="MENU_SIZE" CONTENT="WIDTH='16' HEIGHT='16'">
//
//	<!-- The following Code is for defining the Font used for displaying the Menu Text -->
//	<!-- Note: MENU_CLASS and be used instead of MENU_FONT_T for Backward Compatability -->
//	<!-- MENU_FONT_T	= Defines Fonts for Top Level Menus -->
//	<!-- MENU_FONT_S	= Defines Fonts for Sub Level Menus (uses MENU_FONT_T if undefined) -->
//	<!-- Delete lines if not required -->
//	<META NAME="MENU_FONT_T" CONTENT="CLASS = 'MenuText2'">
//
//	<!-- The following Code defines the type of Menu to be Displayed and must be one of -->  
//	<!-- DOWN (default) = Vertical Menu -->  
//	<!-- ACROSS	    = Horizontal Drop Down Menu -->  
//	
//	<META NAME="MENU_DELIM" CONTENT = "">
//
//	<!-- Define the Menu Contents --> 
//	<!-- Each line should hold parameters as follows:-->
//	<!-- Menu LevelMenu TitleMenu Link or *NONE*Menu Comments or *NONE*true for new window, else false$-->
//	<!-- Example: -->
//	<!-- <META NAME="Menu" CONTENT = "1Top LevelTopOne.htm*NONE*false -->
//	<!-- 22 LevelNextOne.htm*NONE*false -->
//	<!-- "> -->
//	<META NAME="Menu" CONTENT = "**** see comments above ***">
//
//	<!-- END MENU ENVIRONMENT -->  
//
//	<!-- INCLUDE THE JAVASCRIPT REQUIRED TO RUN THE MENU -->  
//	<SCRIPT LANGUAGE="JavaScript" SRC="BLMenu.js">
//	</SCRIPT>
//
//	<!-- END MENU CODE COPY HERE -->
// =============================================================================================================================
// UPDATE HISTORY
// ==============
//
// 14th Jan 2001	Adrian Cornwell		- Documented this Code
// 3rd Jul 2002		Adrian Cornwell		- Added Font Class Support
// 16 Jan 2003		Adrian Cornwell		- Bug Fix for Drop Down Menus
// 28 Jan 2003		Adrian Cornwell		- Added MENU_WIDTH Support
// 26 Mar 2004		Adrian Cornwell		- Modified to handle Netscape Navigator Browser
// =============================================================================================================================
//		
{
var aMENU = new Array();		// Menu Text
var aLEVEL = new Array();		// Menu Levels
var aDIVID = new Array();		// Holds DIVID for Block containing this Menu Item
var aPDIVID1 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID2 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID3 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID4 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID5 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID6 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID7 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID8 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID9 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aPDIVID10 = new Array()		// Holds Parent Menu DIVID (0 for None)
var aIMGFLAG = new Array();		// True if Image Processing used for this option, else False
var aIMGOPEN = new Array();		// Holds True if Image in Open Position (sub menu displayed) or False if Closed

var aDIVOPEN = new Array();		// Status of each DIV Block. True for Open, False for Closed. Note that we are starting this array from element 1, element 0 is not used.

var aPSUB = new Array();		// Subscript for Menu Options Parents (0 for Top Levels)

var cPLUS = "";				// Graphic for Plus sign
var cMINUS = "";			// Graphic for Minus sign
var cNONE = "";				// Graphic for None Graphic Options
var cSIZE = "";				// Sizing Parameters for Menu Graphics
var cWIDTH_T = "";			// Sizing Parameter for Menu Width top menus
var cWIDTH_S = "";			// Sizing Parameter for Menu Width sub menus
var lGRAPHICS = false;			// Graphics used flag
var cFONT_T = "";			// Font for Top Level Menus
var cFONT_S = "";			// Font for Sub Menus
var cPADDER = " &nbsp &nbsp "		// Padding for Menu (Can be overridden by using Meta Tag MENU_PADDER
var cTYPE = "NORMAL";			// Menu Type
var lINIT_NAMES = false;		// Graphics Initialisation Flag

}


function close_menu()
{
// ===============================================================================================
// Function:	close_menu
// Description:
//	This function compresses (closes) all menu options
// Parameters:
//	None
//
// ===============================================================================================
var nMAX = aMENU.length;

for (var nSUB = 0;nSUB < nMAX;nSUB++)
	{
	if (aLEVEL[nSUB] > 1 && document.getElementById("M_" + aDIVID[nSUB]).style.display != "none")
		document.getElementById("M_" + aDIVID[nSUB]).style.display = "none";

	if (lGRAPHICS == true)
		{
		if (document.getElementById("I_" + (nSUB)).src != cNONE)
			document.getElementById("I_" + (nSUB)).src = cPLUS;
		}
	}
}

function print_text(pTEXT)
// ===============================================================================================
// Function:	print_text
// Description:
//	A Output goes via this function, this makes life easier for debugging and tracking problems.
// Parameters:
//	- String to Print
//
// ===============================================================================================
{
	document.write(pTEXT);
}

function refresh_menu(pSTART_SUB)
{
// ===============================================================================================
// Function:	refresh_Menu
// Description:
//	This Function refreshes a part of the menu when a menu option is clicked and opens/closes
// 	sub levels as required.
// Parameters:
//	- The Subscript in the Menu Array to Start the Drill Down from
//
// ===============================================================================================
var nMAX = aMENU.length;
var nDIVID = 0;
var nMENU_SUB=pSTART_SUB+1;			// Main Menu Subscript

if (pSTART_SUB == nMAX-1)
	return;

if (cTYPE == "DROPDOWN" && aDIVOPEN[aDIVID[nMENU_SUB]] == true)	// If Current Drop Down Menu Open, Close all others
	{
		// for Drop Down Menus, close all unused items
		{
		for (var nSUB=0;nSUB<aMENU.length;nSUB++)
			{
			if (aDIVID[nMENU_SUB] != aDIVID[nSUB] && aPDIVID1[nMENU_SUB] != aDIVID[nSUB] && aPDIVID2[nMENU_SUB] != aDIVID[nSUB] && aPDIVID3[nMENU_SUB] != aDIVID[nSUB] && aPDIVID4[nMENU_SUB] != aDIVID[nSUB] && aPDIVID5[nMENU_SUB] != aDIVID[nSUB] && aPDIVID6[nMENU_SUB] != aDIVID[nSUB] && aPDIVID7[nMENU_SUB] != aDIVID[nSUB] && aPDIVID8[nMENU_SUB] != aDIVID[nSUB] && aPDIVID9[nMENU_SUB] != aDIVID[nSUB] && aPDIVID10[nMENU_SUB] != aDIVID[nSUB])
				{
				if (aDIVOPEN[aDIVID[nSUB]] == true)	// Its open, so Close
					{
					aDIVOPEN[aDIVID[nSUB]] = false;
					aIMGOPEN[nSUB-1] = false;
					document.getElementById("M_" + aDIVID[nSUB]).style.display = "none";
	
					// Display Graphics
					if (lGRAPHICS == true && aIMGFLAG[nSUB-1] == true)
						{
						if (aIMGOPEN[nSUB-1] == true)
							document.getElementById("I_" + (nSUB-1)).src = cMINUS;
						else
							document.getElementById("I_" + (nSUB-1)).src = cPLUS;
						}

					}
				}
			}
		}
	return;
	}

if (aDIVOPEN[aDIVID[nMENU_SUB]] == true)	// Close Menu
	{	
	nDIVID = aDIVID[nMENU_SUB];
	aDIVOPEN[nDIVID] = false;
	aIMGOPEN[pSTART_SUB] = false;
	document.getElementById("M_" + nDIVID).style.display = "none";

	// Display Graphics
	if (lGRAPHICS == true && aIMGFLAG[pSTART_SUB] == true)
		{
		if (aIMGOPEN[pSTART_SUB] == true)
			document.getElementById("I_" + (pSTART_SUB)).src = cMINUS;
		else
			document.getElementById("I_" + (pSTART_SUB)).src = cPLUS;
		}


	// We Also Need to Close all Sub Menus if a normal menu
	for (var nSUB=nMENU_SUB+1;nSUB<aMENU.length;nSUB++)
		{
		if (aPDIVID1[nSUB] == nDIVID || aPDIVID2[nSUB] == nDIVID || aPDIVID3[nSUB] == nDIVID || aPDIVID4[nSUB] == nDIVID || aPDIVID5[nSUB] == nDIVID || aPDIVID6[nSUB] == nDIVID || aPDIVID7[nSUB] == nDIVID || aPDIVID8[nSUB] == nDIVID || aPDIVID9[nSUB] == nDIVID || aPDIVID10[nSUB] == nDIVID)
			{
			if (aDIVOPEN[aDIVID[nSUB]] == true)	// Its open, so Close
				{
				aDIVOPEN[aDIVID[nSUB]] = false;
				aIMGOPEN[nSUB-1] = false;
				document.getElementById("M_" + aDIVID[nSUB]).style.display = "none";

				// Display Graphics
				if (lGRAPHICS == true && aIMGFLAG[nSUB-1] == true)
					{
					if (aIMGOPEN[nSUB-1] == true)
						document.getElementById("I_" + (nSUB-1)).src = cMINUS;
					else
						document.getElementById("I_" + (nSUB-1)).src = cPLUS;
					}
				}
			}
		}
	}
else						// Open Menu
	{
	aDIVOPEN[aDIVID[nMENU_SUB]] = true;
	aIMGOPEN[pSTART_SUB] = true;
	document.getElementById("M_" + aDIVID[nMENU_SUB]).style.display = "";

	// Display Graphics
	if (lGRAPHICS == true && aIMGFLAG[pSTART_SUB] == true)
		{
		if (aIMGOPEN[pSTART_SUB] == true)
			document.getElementById("I_" + (pSTART_SUB)).src = cMINUS;
		else
			document.getElementById("I_" + (pSTART_SUB)).src = cPLUS;
		}
	}
	if (cTYPE=="DROPDOWN")
		// for Drop Down Menus, close all unused items
		{
		for (var nSUB=0;nSUB<aMENU.length;nSUB++)
			{
			if (aDIVID[nMENU_SUB] != aDIVID[nSUB] && aPDIVID1[nMENU_SUB] != aDIVID[nSUB] && aPDIVID2[nMENU_SUB] != aDIVID[nSUB] && aPDIVID3[nMENU_SUB] != aDIVID[nSUB] && aPDIVID4[nMENU_SUB] != aDIVID[nSUB] && aPDIVID5[nMENU_SUB] != aDIVID[nSUB] && aPDIVID6[nMENU_SUB] != aDIVID[nSUB] && aPDIVID7[nMENU_SUB] != aDIVID[nSUB] && aPDIVID8[nMENU_SUB] != aDIVID[nSUB] && aPDIVID9[nMENU_SUB] != aDIVID[nSUB] && aPDIVID10[nMENU_SUB] != aDIVID[nSUB])
				{
				if (aDIVOPEN[aDIVID[nSUB]] == true)	// Its open, so Close
					{
					aDIVOPEN[aDIVID[nSUB]] = false;
					aIMGOPEN[nSUB-1] = false;
					document.getElementById("M_" + aDIVID[nSUB]).style.display = "none";
	
					// Display Graphics
					if (lGRAPHICS == true && aIMGFLAG[nSUB-1] == true)
						{
						if (aIMGOPEN[nSUB-1] == true)
							document.getElementById("I_" + (nSUB-1)).src = cMINUS;
						else
							document.getElementById("I_" + (nSUB-1)).src = cPLUS;
						}

					}
				}
			}
		}

}

function print_item(pSUB,pTD,pPAD,pGTD)
{
// ===============================================================================================
// Function:	print_item
// Description:
//	Function called by the init_<type>_menu functions to print a single menu item.
//
// Parameters:
//	- Subscript of the Menu Item to Print
//	- Formatted <TD> Marker for this particular Level without closing bracket
//	- Padding String for this menu Item
// ===============================================================================================
var cSRC = "";		// Graphics Image
var cWIDTH = "";	// Menu Width Settings

	// Set up Width
	if (aLEVEL[pSUB] > 1)	// Sub Menu
	{
		cWIDTH = cWIDTH_S;
	}
	else			// Top Menu
	{
		cWIDTH = cWIDTH_T;
	}

	// Mouseover event required if sub menus exist for this item
	if (aIMGFLAG[pSUB]==true)	// Sub Menus Exist
		{
		if (cTYPE == "DROPDOWN")
			print_text(	"<DIV ID=MI_" + pSUB + " STYLE='cursor:hand;' onMouseOver='refresh_menu(" + pSUB + ")'>");
		else
			print_text(	"<DIV ID=MI_" + pSUB + " STYLE='cursor:hand;' onClick='refresh_menu(" + pSUB + ")'>");
		}
	else				// No Sub Menus
		{
		if (cTYPE == "DROPDOWN")
			print_text(	"<DIV ID=MI_" + pSUB + " STYLE='cursor:hand;' onMouseOver='refresh_menu(" + pSUB + ")'>");
		else
			print_text(	"<DIV ID=MI_" + pSUB + " STYLE='cursor:hand;'>");
		}


	// Print Graphic if required
	if (lGRAPHICS == true)
		{
		// Define a Table to hold this Item
		if (pPAD == "")
			print_text(	"<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0' VALIGN='CENTER' HALIGN='LEFT'><TR>" + pTD + ">");
		else
			print_text(	"<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0' VALIGN='CENTER' HALIGN='LEFT'><TR>" + pTD + ">" + pPAD + "</TD>" + pTD + ">");

		// Setup the Graphic
		if (aIMGFLAG[pSUB]==true)
			cSRC = cPLUS;
		else
			cSRC = cNONE;

		print_text("<IMAGE ID=I_" + pSUB + " SRC='" + cSRC + "' " + cSIZE +  ">");
		print_text(	"</TD>" + pTD + " " + cWIDTH +  ">");
		// Initialise Graphic Names (ie: Add Path) if not already done
		if (lINIT_NAMES==false)
			{
			document.getElementById("I_" + (pSUB)).src = cPLUS;
			cPLUS = document.getElementById("I_" + (pSUB)).src;

			document.getElementById("I_" + (pSUB)).src = cMINUS;
			cMINUS = document.getElementById("I_" + (pSUB)).src;

			document.getElementById("I_" + (pSUB)).src = cNONE;
			cNONE = document.getElementById("I_" + (pSUB)).src;

			document.getElementById("I_" + (pSUB)).src = cSRC;
			lINIT_NAMES = true;
			}
		}
	else
		{
		// Define a Table to hold this Item
		if (pPAD == "")
			print_text(	"<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0' VALIGN='CENTER' HALIGN='LEFT'><TR>" + pTD + " " + cWIDTH +  ">");
		else
			print_text(	"<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0' VALIGN='CENTER' HALIGN='LEFT'><TR>" + pTD +  ">" + pPAD + "</TD>" + pTD + " " + cWIDTH +  ">");

		}
	print_text(aMENU[pSUB] + "&nbsp;");
	print_text(	"</TD></TR></TABLE></DIV>");

	// Set the position for DropDowns. Same Y Position as the Parent Menu Item
	if (cTYPE=="DROPDOWN")
		document.getElementById("M_" + aDIVID[pSUB]).style.top = document.getElementById("MI_" + pSUB).style.top;
}


function init_NORMAL_menu()
{
// ===============================================================================================
// Function:	init_NORMAL_menu
// Description:
//	This function initialises the Normal Column Menu onto the HTML Page by printing 
//	out the DIV Tags and Menu Options.
//
// Parameters:
//	None
//
// ===============================================================================================
var nMAX = aMENU.length;
var cPAD = "";
var nLASTDIVID = 0;	// Last DIV ID Printed
var nLASTLEVEL = 0;	// Last Level

// Setup HTML Code for <TD> Markers
var cTD1 = "";		// <TD> Definition for Level 1
var cTD2 = "";		// <TD> Definition for Level 2...

if (cFONT_T == "")
	cTD1 = "<TD>";
else
	cTD1 = "<TD " + cFONT_T;
if (cFONT_S == "")
	cTD2 = "<TD>";
else
	cTD2 = "<TD " + cFONT_S;


print_text("<BR>");

for (var nSUB = 0;nSUB < nMAX;nSUB++)
	{
	// Setup Menu Padding (indentation)
	cPAD = "";
	if (aLEVEL[nSUB] > 1)
		{
		// Pad Menu Item with spaces for identation
		for (var nSUB2 = 2;nSUB2 <= aLEVEL[nSUB];nSUB2++)
			{
			cPAD = cPAD + cPADDER;
			}
		}

	// Print New Block if starting a New Menu
	if (aDIVID[nSUB] < nLASTDIVID)	// Old Menu Block
		{
		for (var nWRK = aLEVEL[nSUB];nWRK < nLASTLEVEL;nWRK++)
			print_text("</DIV>"); 
		}

	if (aDIVID[nSUB] > nLASTDIVID)	// New Menu Block
		print_text(	"<DIV STYLE='cursor:hand;' ID=M_" + aDIVID[nSUB]  + ">");


	// Print the Item
	if (aLEVEL[nSUB] == 1)
		print_item(nSUB,cTD1,cPAD);
	else
		print_item(nSUB,cTD2,cPAD);

	nLASTDIVID = aDIVID[nSUB];
	nLASTLEVEL = aLEVEL[nSUB];

	}
// Close any Open Menus and Set visibility
	print_text("</TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV></TD></TR></TABLE></DIV>"); 

	for (var nSUB = 1;nSUB < aDIVOPEN.length;nSUB++)
		{
		if (aDIVOPEN[nSUB] == false)
			document.getElementById("M_" + nSUB).style.display = "none";
		}
}


function init_DROPDOWN_menu()
{
// ===============================================================================================
// Function:	init_DROPDOWN_menu()
// Description:
//	This function initialises the Dropdown Menu onto the HTML Page by printing 
//	out the DIV Tags and Menu Options.
//
// Parameters:
//	None
//
// ===============================================================================================
var nMAX = aMENU.length;
var nLASTDIVID = 0;	// Last DIV ID Printed
var nLASTLEVEL = 0;	// Last Level
var nMAXLEVEL = 0;	// Total Number of Levels to Process
var nPERCENT = 0;	// Percentage of Display for Each Level 1
var nPOS = 0;		// Number of options in current Level 1 Menu
var lFIRST=false;	// First Option Printed Flag

// Setup HTML Code for <TD> Markers
var cTD1 = "";		// <TD> Definition for Level 1
var cTD2 = "";		// <TD> Definition for Level 2...

if (lGRAPHICS==true)
	cTD1 = "<TD ";
else
	cTD1 = "<TD ALIGN='CENTER' ";

if (cFONT_T != "")
	cTD1 = cTD1 + cFONT_T;

if (cFONT_S == "")
	cTD2 = "<TD";
else
	cTD2 = "<TD " + cFONT_S;

// Find Total Number of Level 1 Options
for (var nSUB = 0;nSUB < nMAX;nSUB++)
	{
	if (aLEVEL[nSUB] == 1)
		nPERCENT++;
	}

if (nPERCENT > 0)
	nPERCENT = (100/nPERCENT);

print_text("<BR>");

// Find Max Depth for the Menu
for (var nSUB = 0;nSUB < nMAX;nSUB++)
	{
	if (eval(aLEVEL[nSUB]) > nMAXLEVEL)
		nMAXLEVEL = eval(aLEVEL[nSUB]);
	}

// Print Level 1 Menu across the Page
nPOS=0;
print_text(	"<DIV STYLE='cursor:hand;' ID=M_" + aDIVID[1] + " >");
print_text(	"<TABLE BORDER='1' CELLSPACING='0' CELLPADDING='0' VALIGN='CENTER' HALIGN='CENTER' WIDTH='100%'><TR>" + cTD1  + ">");

for (var nSUB = 0;nSUB < nMAX;nSUB++)	// Check each Menu
	{
	if (aLEVEL[nSUB] == 1)	// Only interested in Level 1
		{
		nPOS++;
		print_text(	"</TD>" + cTD1 + ">");
		print_item(nSUB,cTD1,"");
		}
	}

print_text("</TD></TR></TABLE></DIV>"); 


// Print each Menu Block, processing a level at a time
lFIRST=false;	
for (var nLEVEL = 2;nLEVEL <= nMAXLEVEL;nLEVEL++)	// Level Loop
	{
	nPOS = 0;
	nLASTDIVID = 0;

	for (var nSUB = 0;nSUB < nMAX;nSUB++)	// Check each Menu
		{
		if (aLEVEL[nSUB] == 1)	// Increment Level 1 Positions
			nPOS++;

		if (aLEVEL[nSUB] == nLEVEL)	// Only interested in a particular Level
			{
			// Print the Menu Item
			if (aDIVID[nSUB] > nLASTDIVID && lFIRST == true)	// Old Menu Block
				print_text("</TD></TR></TABLE></DIV>"); 

			if (aDIVID[nSUB] > nLASTDIVID)	// New Menu Block
				{
				nLASTLEVEL = aLEVEL[nSUB];
				lFIRST=true;
				print_text(	"<DIV STYLE='position:absolute;left:" + ((nPERCENT * (nPOS-1))+ ((nPERCENT * .25) * (nLEVEL-2))) + "%;top:0px;cursor:hand;' ID=M_" + aDIVID[nSUB] + " >");
				print_text(	"<TABLE BORDER=" + aLEVEL[nSUB] + " CELLSPACING='0' CELLPADDING='0' VALIGN='CENTER' HALIGN='CENTER'><TR>" + cTD2 + ">");
				}
	
			else				// Just another Menu Option
				print_text(	"</TD></TR><TR>" + cTD2 + ">");

			print_item(nSUB,cTD2,"");	// Print the Item
			nLASTDIVID = aDIVID[nSUB];

			}

		}
	}
	// Close any Open Menus and Set visibility
	print_text("</TD></TR></TABLE></DIV>"); 
	for (var nSUB = 1;nSUB < aDIVOPEN.length;nSUB++)
		{
		if (aDIVOPEN[nSUB] == false)
			document.getElementById("M_" + nSUB).style.display = "none";
		}

}

function add_menu_item(pLEVEL,pDESCRIPTION,pHREF,pCOMMENT,pNEW_WINDOW)
{
// ===============================================================================================
// Function:	add_menu_item
// Description:
//	This function adds an Item to the Menu Array.
// Parameters:
//	- Display Level in the Menu for the Item to be displayed
//	- The Displayed Text for the Item
//	- The URL to follow for the Item or *NONE* if none
//	- Displayed Comments for the Menu Item or *NONE* if none
//	- New Window action when Item Selected.
//		true	- New Window
//		false	- No New Window
//		_parent	- Parent Window
//		_self	- This Window
//
// ===============================================================================================

var nLEVEL=0;		// Work Var
var nID=0;		// Work Var
var nPARENT=0;		// Work Var

	if (pLEVEL == null || pDESCRIPTION == null)
		return;
	var cSTR = "";
	var cCOMMENT = "";
	var cTARGET = "";

	switch (pNEW_WINDOW.toUpperCase())
	{
	case "TRUE":
		cTARGET = " TARGET='_parent'";
		break;

	case "SELF":
		cTARGET = " TARGET='_self'";
		break;

	case "BLANK":
		cTARGET = " TARGET='_blank'";
		break;

	case "_SELF":
		cTARGET = " TARGET='_self'";
		break;

	case "_BLANK":
		cTARGET = " TARGET='_blank'";
		break;
	}
	if (pCOMMENT != "*NONE*")
		cCOMMENT = pCOMMENT;

	// Add the Item
	aMENU.length++;
	aLEVEL.length++;
	aDIVID.length++;
	aPDIVID1.length++;
	aPDIVID2.length++;
	aPDIVID3.length++;
	aPDIVID4.length++;
	aPDIVID5.length++;
	aPDIVID6.length++;
	aPDIVID7.length++;
	aPDIVID8.length++;
	aPDIVID9.length++;
	aPDIVID10.length++;
	aIMGOPEN.length++;
	aIMGFLAG.length++;

	aIMGOPEN[aIMGOPEN.length-1] = false;
	aIMGFLAG[aIMGFLAG.length-1] = false;

	if (pHREF == "*NONE*")
		aMENU[aMENU.length-1] = cSTR +  pDESCRIPTION + " " + cCOMMENT;
	else
		aMENU[aMENU.length-1] = cSTR + " <A HREF='" + pHREF + "' " + cTARGET +">" + pDESCRIPTION + "</A> " + cCOMMENT;

	aLEVEL[aLEVEL.length-1] = pLEVEL;

	// If this Level is higher then Previous Level, then imaging must be switched on for the previous one.
	if (aMENU.length > 1)	// Not First One
		{
		if (aLEVEL[aLEVEL.length-1] > aLEVEL[aLEVEL.length-2])
			aIMGFLAG[aIMGFLAG.length-2] = true;
		}

	// Can we use an existing DIVID or do we need a new one. DIVID = 0 is for new one required.
	aDIVID[aDIVID.length-1] = 0;
	if (aMENU.length > 1)		// Only test if not the first menu item
	{
		// If this Level is the same as the Previous Level then use the same DIVID
		if (aLEVEL[aLEVEL.length-2] == eval(pLEVEL))
			aDIVID[aDIVID.length-1] = aDIVID[aDIVID.length-2];
		else
		{
		// Step Back to find the next possible parent (which will have the same level as this)
			for (var nSUB = aLEVEL.length-2;nSUB >=0;nSUB--)
			{
				if (aLEVEL[nSUB] < pLEVEL)
					nSUB=-1;	// Exit Loop
				else
				{
					if (aLEVEL[nSUB] == pLEVEL)
					{
						aDIVID[aDIVID.length-1] = aDIVID[nSUB];
						nSUB=-1;	// Exit Loop
					}
				}
			}
		}
	}

	// Allocate DIVID if required
	if (aDIVID[aDIVID.length-1] == 0)
	{
		aDIVOPEN.length++;
		if (aDIVOPEN.length == 2)	// First one always open
			aDIVOPEN[aDIVOPEN.length-1] = true;
		else
			aDIVOPEN[aDIVOPEN.length-1] = false;

		aDIVID[aDIVID.length-1] = aDIVOPEN.length-1;
	}

	// Find the ID's of the Parents for this Menu Item, by stepping backwards through the menus
	aPDIVID1[aPDIVID1.length-1] = 0;
	aPDIVID2[aPDIVID2.length-1] = 0;
	aPDIVID3[aPDIVID3.length-1] = 0;
	aPDIVID4[aPDIVID4.length-1] = 0;
	aPDIVID5[aPDIVID5.length-1] = 0;
	aPDIVID6[aPDIVID6.length-1] = 0;
	aPDIVID7[aPDIVID7.length-1] = 0;
	aPDIVID8[aPDIVID8.length-1] = 0;
	aPDIVID9[aPDIVID9.length-1] = 0;
	aPDIVID10[aPDIVID10.length-1] = 0;

	nLEVEL = aLEVEL[aLEVEL.length-1];		// Initialise Level to Test

	for (var nSUB = (aDIVID.length-2);nSUB >=0;nSUB--)
	{
		if (aLEVEL[nSUB] < nLEVEL)
			{
			switch (nPARENT)
				{
				case 0:
					aPDIVID1[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 1;
					break;
				case 1:
					aPDIVID2[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 2;
					break;
				case 2:
					aPDIVID3[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 3;
					break;
				case 3:
					aPDIVID4[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 4;
					break;
				case 4:
					aPDIVID5[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 5;
					break;
				case 5:
					aPDIVID6[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 6;
					break;
				case 6:
					aPDIVID7[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 7;
					break;
				case 7:
					aPDIVID8[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 8;
					break;
				case 8:
					aPDIVID9[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 9;
					break;
				case 9:
					aPDIVID10[aDIVID.length-1] = aDIVID[nSUB];
					nPARENT = 10;
					break;
				}
			nLEVEL = aLEVEL[nSUB];
			}
	}
	
}

function build_menu()
{
// ===============================================================================================
// Function:	build_menu
// Description:
//	This function scans the documents Meta Tags and builds up the Menu Arrays.
// Parameters:
//	None
//
// ===============================================================================================
var cCONTENTS = "";
var cDELIM = ",";
var aTAG = document.getElementsByTagName("META");
var nMAX = aTAG.length;
aDIVOPEN.length++;		// Baseline this for Subscript 1

for (var nSUB = 0;nSUB < nMAX;nSUB++)
	{
	if (aTAG[nSUB].name.toUpperCase() == "MENU")
		cCONTENTS = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_DELIM")
		cDELIM = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_PLUS")
		cPLUS = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_MINUS")
		cMINUS = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_NONE")
		cNONE = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_SIZE")
		cSIZE = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_WIDTH_T")
		cWIDTH_T = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_WIDTH_S")
		cWIDTH_S = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_FONT_T")
		cFONT_T = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_CLASS")
		cFONT_T = "CLASS = '" + aTAG[nSUB].content + "'";

	if (aTAG[nSUB].name.toUpperCase() == "MENU_FONT_S")
		cFONT_S = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_PADDER")
		cPADDER = aTAG[nSUB].content;

	if (aTAG[nSUB].name.toUpperCase() == "MENU_TYPE")
		cTYPE = aTAG[nSUB].content;

	}


// Set up Default Fonts
if (cFONT_S == "")
	cFONT_S = cFONT_T;

if (cCONTENTS == "")
	return;		// No Menu Found

if (cPLUS != "" && cMINUS != "" && cNONE != "")
	lGRAPHICS = true;

// The Contents Value of this Tag, should contain menu strings
//	Level,Desc,Link,Comment
// We can now split these out to an Array.

var aCONTENTS = cCONTENTS.split(cDELIM);
nMAX = aCONTENTS.length;

// Add Menu Item for each Block of 5 Elements in the Array
for (var nSUB = 0;nSUB < nMAX;nSUB=nSUB+5)
	{

	// Create a Dummy (Blank) Menu item if going down a level and using a drop down menu
	if (aMENU.length > 1 && cTYPE != "NORMAL")
	{
		if (aCONTENTS[nSUB] < aLEVEL[aLEVEL.length-1])	// Going down a level so add dummy row
			add_menu_item(aLEVEL[aLEVEL.length-1],"","*NONE*","*NONE*","false");
	}


	add_menu_item(aCONTENTS[nSUB],aCONTENTS[nSUB+1],aCONTENTS[nSUB+2],aCONTENTS[nSUB+3],aCONTENTS[nSUB+4]);
	}

if (cTYPE == "NORMAL")
	init_NORMAL_menu();
else
	init_DROPDOWN_menu();

document.getElementById("LOADING").style.display = "none";
}


function Show_All_Items()
{
// ===============================================================================================
// Function:	Show_All_Items
// Description:
//	This function expands the Menu to show all Items.
// Parameters:
//	None
//
// ===============================================================================================
var nMAX = aMENU.length;

for (var nSUB = 0;nSUB < nMAX;nSUB++)
	{
	if (aLEVEL[nSUB] > 1 && document.getElementById("M_" + aDIVID[nSUB]).style.display == "none")
		document.getElementById("M_" + aDIVID[nSUB]).style.display = "";

	if (lGRAPHICS == true)
		{
		if (document.getElementById("I_" + (nSUB)).src != cNONE)
			document.getElementById("I_" + (nSUB)).src = cMINUS;
		}
	}
}

// ===============================================================================================
// Function:	Start Up
// Description:
//	This is the Startup procedure and builds/displays the Menu onto the HTML Page.
// Parameters:
//	None
//
// ===============================================================================================
{
build_menu();
}

