echo off
rem module:	quickconvert.bat
rem Author:	Adrian Cornwell @ www.dev2go.com
rem Description:
rem	This DOS program provides a simple interface for performing
rem	various conversion and replace functions using a simple
rem 	dos menu.
rem ======================================================================
rem Configuration
rem ======================================================================
rem Depending on the directory in which you installed fileconvert you
rem may need to change the parameters below


rem Set the parameter below to the directory in which you have installed
rem fileconvert

SET FCDIR=c:\fileconvert

rem Set the parameter below to the directory in which you would like
rem temporary files created.

SET FTEMP=c:\temp

rem ======================================================================
rem Display Welcome and start up
rem ======================================================================

:MENU
cls
echo ======================================================
echo quickconvert
echo a multi-purpose conversion utility using fileconvert
echo Author: Adrian Cornwell @ dev2go.Com
echo ======================================================
echo ======================= MENU =========================
echo ======================================================
echo Please enter the action you wish to perform
echo H - Search fileconvert documentation
echo D - Convert File(S) from Unix to DOS Format
echo U - Convert File(s) from DOS to Unix Format
echo R - Perform a String Search and Replace
echo S - Perform a Search
echo C - Convert a CSV File and generate a Template
echo X - Exit
echo ======================================================
set p1=
set /P p1=Enter Option:

rem ==========================================
rem === Redirect based on Selection
rem ==========================================

if "%p1%" == "D"	goto OK
if "%p1%" == "d"	goto OK
if "%p1%" == "U"	goto OK
if "%p1%" == "u"	goto OK
if "%p1%" == "r"	goto OK
if "%p1%" == "R"	goto OK
if "%p1%" == "s"	goto OK
if "%p1%" == "S"	goto OK
if "%p1%" == "C"	goto CSV
if "%p1%" == "c"	goto CSV
if "%p1%" == ""	exit
:OK

rem ==========================================
rem === Before generating files get the
rem === filenames and do a directory listing
rem ==========================================

echo ======================================================
set p2=
set /P p2=Enter Filename (wildcards allowed):
if "%p2%" == ""	exit

echo Extracting file List to %FTEMP%\_mqctemp2.txt ..
dir %p2% /B /S >"%FTEMP%\_mqctemp2.txt


rem ===== Continue from Menu Selections

if "%p1%" == "D"	goto UNIX2DOS
if "%p1%" == "d"	goto UNIX2DOS

if "%p1%" == "U"	goto DOS2UNIX
if "%p1%" == "u"	goto DOS2UNIX

if "%p1%" == "R"	goto SRCHREP
if "%p1%" == "r"	goto SRCHREP

if "%p1%" == "S"	goto SEARCH
if "%p1%" == "s"	goto SEARCH

goto MENU

:UNIX2DOS
rem ==========================================
rem === UNIX2DOS
rem ==========================================
echO Converting Unix Files to DOS  ...

echo Generate a Temp BAT File ...
%FCDIR%\fileconvert -S -I"%FTEMP%\_mqctemp2.txt" -T"%FCDIR%\templates\make_bat.txt" -O"%FTEMP%\_mqctemp2.bat" -P1"%FCDIR%" -P2"%FCDIR%\templates\unix2dos.txt" -P3"-OINPUTFILE"

echo Converting Files...
call "%FTEMP%\_mqctemp2.bat"
goto EXIT



:DOS2UNIX
rem ==========================================
rem === DOS2UNIX
rem ==========================================
echO Converting DOS Files to Unix  ...

echo Generate a Temp BAT File ...
%FCDIR%\fileconvert -S -I"%FTEMP%\_mqctemp2.txt" -T"%FCDIR%\templates\make_bat.txt" -O"%FTEMP%\_mqctemp2.bat" -P1"%FCDIR%" -P2"%FCDIR%\templates\dos2unix.txt" -P3"-OINPUTFILE"

echo Converting Files...
call "%FTEMP%\_mqctemp2.bat"
goto EXIT




:SRCHREP
rem ==========================================
rem === Search and Replace Template
rem ==========================================

echo ======================================================
echo To use special non-printable characters you can enter
echo [:dec:] within the strings where dec = the ascii code
echo of the character.
echo Examples:
echo [:13:]	- Carriage Return
echo [:10:]	- Linefeed
echo [:9:]	- Tab
echo ======================================================
set p3=
set p4=
set p5=
set /P p3=Enter string to search for:
if "%p3%" == ""	exit
set /P p4=Enter Replacement string :
set /P p5=Enter Y to ignore case when searching :

echo Generate a Temp BAT File ...
if "%p5%" == "Y"	goto SR2
if "%p5%" == "y"	goto SR2
rem Case Sensitve Version
%FCDIR%\fileconvert -S -I"%FTEMP%\_mqctemp2.txt" -T"%FCDIR%\templates\make_bat.txt" -O"%FTEMP%\_mqctemp2.bat" -P1"%FCDIR%" -P2"%FCDIR%\templates\sreplace2.txt" -P3"-OINPUTFILE -P1{:34}%P3%{:34} -P2{:34}%P4%{:34}"
goto SROK

:SR2
%FCDIR%\fileconvert -S -I"%FTEMP%\_mqctemp2.txt" -T"%FCDIR%\templates\make_bat.txt" -O"%FTEMP%\_mqctemp2.bat" -P1"%FCDIR%" -P2"%FCDIR%\templates\sreplace1.txt" -P3"-OINPUTFILE -P1{:34}%P3%{:34} -P2{:34}%P4%{:34}"
:SROK
echo Refining Command File
%FCDIR%\fileconvert -S -I"%FTEMP%\_mqctemp2.bat" -T"%FCDIR%\templates\refine_bat.txt" -OINPUTFILE

echo Performing Search and Replace ...
call "%FTEMP%\_mqctemp2.bat"
goto EXIT


:SEARCH
rem ==========================================
rem === Perform a Search
rem ==========================================
echo ======================================================
echo To use special non-printable characters you can enter
echo {:dec:} within the strings where dec = the ascii code
echo of the character.
echo Examples:
echo {:13:}	- Carriage Return
echo {:10:}	- Linefeed
echo {:9:}	- Tab
echo ======================================================
echo If you have a text file containing a list of search
echo parameters (one per line) you can use this by 
echo entering @filename in the search string.
echo Example:
echo @c:\temp\mysearch.txt
echo ======================================================
set p3=
set /P p3=Enter string to search for:
if "%p3%" == ""	exit
echo Performing Search ...
%FCDIR%\fileconvert  -I"@%FTEMP%\_mqctemp2.txt" -T"%FCDIR%\templates\search.txt" -O"%FTEMP%\_mqcsearch.htm" -P1"%P3%" -P2"%P2%" -F"%P3%"
echo Search Completed. Opening Output
"%FTEMP%\_mqcsearch.htm"
exit


:CSV
rem ==========================================
rem === Convert a CSV File and generate a Template
rem ==========================================
echo ======================================================
set p2=
set /P p2=Enter Filename to convert:
if "%p2%" == ""	exit

echo ======================================================
echo Most CSV Files use a comma (,) or semi-colon (;)
echo as a field delimiter. Please enter the delimiter
echo used in your file below.
echo ======================================================
set p3=
set /P p3=Enter Field Deimiter:
if "%p3%"=="" exit

echo ======================================================
echo To generate (and run) a template to convert this 
echo to a different format enter one of the following:
echo H - Convert CSV File to HTML
echo A - Simply Sort the CSV File Ascending Order (and remove duplicate records)
echo B - Simply Sort the CSV File in Descending Order (and remove duplicate records)
echo ======================================================
set p4=
set /P p4=Enter Conversion Rule:
if "%p4%"=="H" goto CSVH
if "%p4%"=="h" goto CSVH
if "%p4%"=="A" goto CSVA
if "%p4%"=="a" goto CSVA
if "%p4%"=="B" goto CSVB
if "%p4%"=="b" goto CSVB
exit

rem =====================================================
rem Convert to HTML
rem =====================================================
:CSVH
echo Generating Template for CSV Conversion
%FCDIR%\fileconvert -S -I"%p2%" -T"%FCDIR%\templates\gen_csv_html.txt" -O"%FTEMP%\mycsv.txt" -P1"%p3%"
echo Running Fileconvert using Generated Template
%FCDIR%\fileconvert  -I"%p2%" -T"%FTEMP%\mycsv.txt" -O"%FTEMP%\mycsvoutput.htm" -R100
echo Producing Simple HTML Index Page
%FCDIR%\fileconvert  -S -I"%FCDIR%\templates\gen_index.htm" -T"%FCDIR%\templates\sreplace2.txt" -O"%FTEMP%\mycsvindex.htm" -P1"[TEMPLATE]" -P2"%FTEMP%\mycsv.txt"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[DATA]" -P2"%p2%"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[OUTPUT]" -P2"%FTEMP%\mycsvoutput.htm"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[COMMAND]" -P2"%FCDIR%\fileconvert  -I"%p2%" -T"%FTEMP%\mycsv.txt" -O"%FTEMP%\mycsvoutput.htm" -R100"
echo Opening Index File
"%FTEMP%\mycsvindex.htm"
exit

rem =====================================================
rem Sort Ascending
rem =====================================================
:CSVA
echo Generating Template for CSV Conversion
%FCDIR%\fileconvert -S -I"%p2%" -T"%FCDIR%\templates\gen_csv_sort.txt" -O"%FTEMP%\mycsv.txt" -P1"%p3%" -P2"SORT"
echo Running Fileconvert using Generated Template
%FCDIR%\fileconvert  -I"%p2%" -T"%FTEMP%\mycsv.txt" -O"%FTEMP%\mycsvoutput.csv" -R100
echo Producing Simple HTML Index Page
%FCDIR%\fileconvert  -S -I"%FCDIR%\templates\gen_index.htm" -T"%FCDIR%\templates\sreplace2.txt" -O"%FTEMP%\mycsvindex.htm" -P1"[TEMPLATE]" -P2"%FTEMP%\mycsv.txt"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[DATA]" -P2"%p2%"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[OUTPUT]" -P2"%FTEMP%\mycsvoutput.csv"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[COMMAND]" -P2"%FCDIR%\fileconvert  -I"%p2%" -T"%FTEMP%\mycsv.txt" -O"%FTEMP%\mycsvoutput.csv" -R100"
echo Opening Index File
"%FTEMP%\mycsvindex.htm"
exit

rem =====================================================
rem Sort Descending
rem =====================================================
:CSVB
echo Generating Template for CSV Conversion
%FCDIR%\fileconvert -S -I"%p2%" -T"%FCDIR%\templates\gen_csv_sort.txt" -O"%FTEMP%\mycsv.txt" -P1"%p3%" -P2"SORTDESC"
echo Running Fileconvert using Generated Template
%FCDIR%\fileconvert  -I"%p2%" -T"%FTEMP%\mycsv.txt" -O"%FTEMP%\mycsvoutput.csv" -R100
echo Producing Simple HTML Index Page
%FCDIR%\fileconvert  -S -I"%FCDIR%\templates\gen_index.htm" -T"%FCDIR%\templates\sreplace2.txt" -O"%FTEMP%\mycsvindex.htm" -P1"[TEMPLATE]" -P2"%FTEMP%\mycsv.txt"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[DATA]" -P2"%p2%"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[OUTPUT]" -P2"%FTEMP%\mycsvoutput.csv"
%FCDIR%\fileconvert  -S -I"%FTEMP%\mycsvindex.htm" -T"%FCDIR%\templates\sreplace2.txt" -OINPUTFILE -P1"[COMMAND]" -P2"%FCDIR%\fileconvert  -I"%p2%" -T"%FTEMP%\mycsv.txt" -O"%FTEMP%\mycsvoutput.csv" -R100"
echo Opening Index File
"%FTEMP%\mycsvindex.htm"
exit

rem ==============================================
rem All Done
rem ==============================================
:EXIT
pause
exit
